'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ramda;

function _load_ramda() {
  return _ramda = _interopRequireDefault(require('ramda'));
}

var _chalk;

function _load_chalk() {
  return _chalk = _interopRequireDefault(require('chalk'));
}

var _componentRemove;

function _load_componentRemove() {
  return _componentRemove = require('../../scope/component-remove');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (_ref) {
  var dependentBits = _ref.dependentBits,
      _ref$modifiedComponen = _ref.modifiedComponents,
      modifiedComponents = _ref$modifiedComponen === undefined ? [] : _ref$modifiedComponen,
      removedComponentIds = _ref.removedComponentIds,
      missingComponents = _ref.missingComponents;

  var paintMissingComponents = function paintMissingComponents(missingComponents) {
    return !(_ramda || _load_ramda()).default.isEmpty(missingComponents) ? (_chalk || _load_chalk()).default.red.underline('missing components:') + (0, (_chalk || _load_chalk()).default)(` ${missingComponents.map(function (id) {
      return id.version === 'latest' ? id.toStringWithoutVersion() : id.toString();
    })}\n`) : '';
  };
  var paintRemoved = function paintRemoved(removedComponentIds) {
    return !(_ramda || _load_ramda()).default.isEmpty(removedComponentIds) ? (_chalk || _load_chalk()).default.green.underline('successfully removed components:') + (0, (_chalk || _load_chalk()).default)(` ${removedComponentIds.map(function (id) {
      return id.version === 'latest' ? id.toStringWithoutVersion() : id.toString();
    })}\n`) : '';
  };

  var paintUnRemovedComponents = function paintUnRemovedComponents(dependentBits) {
    if (!(_ramda || _load_ramda()).default.isEmpty(dependentBits)) {
      return Object.keys(dependentBits).map(function (key) {
        var header = (_chalk || _load_chalk()).default.underline.red(`error: unable to delete ${key}, because the following components depend on it:`);
        var body = dependentBits[key].join('\n');
        return `${header}\n${body}`;
      }).join('\n\n');
    }
    return '';
  };

  var paintModifiedComponents = function paintModifiedComponents(modifiedComponents) {
    return !(_ramda || _load_ramda()).default.isEmpty(modifiedComponents) ? `${(_chalk || _load_chalk()).default.red.underline('error: unable to remove modified components:') + (0, (_chalk || _load_chalk()).default)(` ${modifiedComponents.map(function (id) {
      return id.version === 'latest' ? id.toStringWithoutVersion() : id.toString();
    })}`)},${(_chalk || _load_chalk()).default.red(' please use --force flag')}` : '';
  };

  return paintUnRemovedComponents(dependentBits) + paintRemoved(removedComponentIds) + paintMissingComponents(missingComponents) + paintModifiedComponents(modifiedComponents);
};